︠70cf05b7-fb85-42c4-a5d7-ada4c3417531i︠
%html
<p>We choose an elliptic curve E:</p>

︡11a3a71e-aed3-4cd6-8fdf-8f8d1b567ea3︡{"html": "<p>We choose an elliptic curve E:</p>"}︡
︠e6029036-6bab-4bba-a286-ca250538be49︠
E=EllipticCurve('37a'); E
︡cb9b24ad-c88f-4838-b571-c9c79a66c325︡{"stdout": "Elliptic Curve defined by y^2 + y = x^3 - x over Rational Field"}︡
︠17f49c1c-3dd9-4e1c-a66e-76ff78ba42e4︠
E.galois_representation().is_surjective(2)
︡3706f428-a515-4ab7-bdac-011bd7518a85︡{"stdout": "True"}︡
︠85047c4a-a17e-45eb-ba2c-cdf0f00556f7︠
rho=E.galois_representation(); rho
︡8d25107a-2e2b-4e36-9109-fd4723f8f25b︡{"stdout": "Compatible family of Galois representations associated to the Elliptic Curve defined by y^2 + y = x^3 - x over Rational Field"}︡
︠4e403f39-3bd4-4940-9246-935f72658606i︠
%html
<p>We choose a Heegner discriminant for E:</p>

︡e56fb20b-cd98-4c3c-9d89-a56bd6f3bc16︡{"html": "<p>We choose a Heegner discriminant for E:</p>"}︡
︠35312bad-033f-4159-8845-c7284bc28cfc︠
E.heegner_discriminants(100)
︡f8aa3f8d-f7c3-469b-99a0-c17ae6f757fe︡{"stdout": "[-3, -4, -7, -11, -40, -47, -67, -71, -83, -84, -95]"}︡
︠40294e4f-1fab-4fc9-94f5-3a2c560f3962i︠
%html
<p>With the choice of a Heegner discriminant, -3, we list possible Kolyvagin primes:</p>

︡8d6f1888-3e89-49a6-bd08-588997028707︡{"html": "<p>With the choice of a Heegner discriminant, -3, we list possible Kolyvagin primes:</p>"}︡
︠9e33b285-7d3f-472d-8444-d0e93d7cf931︠
KolyPrimes=[ell for ell in prime_range(1000) if GF(ell)(E.conductor())!=0 and E.heegner_point(-3,ell).satisfies_kolyvagin_hypothesis(3)]; KolyPrimes
︡fb7250f6-b57e-4709-b484-2d11252f59d7︡{"stdout": "[17, 29, 41, 47, 71, 83, 101, 107, 113, 131, 137, 167, 173, 179, 197, 233, 239, 257, 269, 281, 311, 359, 401, 431, 449, 461, 521, 557, 563, 569, 653, 659, 683, 701, 719, 743, 773, 857, 863, 929, 947, 983]"}︡
︠56de6d46-f3df-43b4-b9b7-486ea391e2e9i︠
%html
<p>We define the field L=Q(E[2]):</p>

︡eeac8976-cfbb-4a73-b06e-168cfae50491︡{"html": "<p>We define the field L=Q(E[2]):</p>"}︡
︠1c27c377-5732-43ed-9b4d-36b0cd414619︠
L.<a>=NumberField(x^6 - 3*x^5 - 2*x^4 + 9*x^3 - 5*x + 1); L
︡60e33aae-9775-43d7-ae93-8e274b4aa0cc︡{"stdout": "Number Field in a with defining polynomial x^6 - 3*x^5 - 2*x^4 + 9*x^3 - 5*x + 1"}︡
︠8e3dcd67-706e-4a49-b3fc-bccccedc2c27︠
L.is_galois()
︡84695a6c-4743-4527-9bdf-e7dddbec3011︡{"stdout": "True"}︡
︠a91e6b1c-da6a-4a97-8a05-d160fdbdd291︠
EL=E.change_ring(L); EL
︡4a9995b0-14ef-4544-a276-0e4ff7b09756︡{"stdout": "Elliptic Curve defined by y^2 + y = x^3 + (-1)*x over Number Field in a with defining polynomial x^6 - 3*x^5 - 2*x^4 + 9*x^3 - 5*x + 1"}︡
︠f925f73f-ea13-41e5-a550-efacde8b36d5︠
L.galois_group().is_isomorphic(SymmetricGroup(3))
︡c22d298a-db24-4106-84e2-9b8aa028951a︡{"stdout": "True"}︡
︠423c1e0c-0ec0-42f0-b0be-ce2151d51efai︠
%html
<p>Indeed, the 2-division polynomial of E factors completely over L:</p>

︡5fa137e6-0787-4d8a-a1ba-8486aeb35f9a︡{"html": "<p>Indeed, the 2-division polynomial of E factors completely over L:</p>"}︡
︠56564a4d-8e3c-47e7-9e95-dfe1b990970f︠
EL.division_polynomial(2).roots(multiplicities=False)
︡55691b9e-8ce5-4f97-b101-74671ad3af78︡{"stdout": "[1/2*a^4 - a^3 - a^2 + 3/2*a, 1/2*a^5 - 3/2*a^4 - a^3 + 4*a^2 + a - 3/2, -1/2*a^5 + a^4 + 2*a^3 - 3*a^2 - 5/2*a + 3/2]"}︡
︠5a760bfc-731c-4a23-a4fb-b7ea994bc91ci︠
%html
<p>We use Robert Miller's number field Selmer group function.</p>

︡e8e4e3d5-a9e5-42e9-8cee-87c0cc2fedac︡{"html": "<p>We use Robert Miller's number field Selmer group function.</p>"}︡
︠a3d8ecdb-a155-4539-b97d-ed0c2e203a03︠
List=L.primes_above(2)
︡f2ccb9fc-a05d-4152-b1ba-a8ecbe8f935f︡︡
︠3e6a0039-1971-4b99-8302-2b37eb0a62af︠
LSelmerGroup=L.selmer_group(List, 2); LSelmerGroup
︡490fc4bd-022d-4074-9b8f-000c980314a3︡{"stdout": "[a^3 - 2*a^2 - 2*a + 3, -1, a^3 - 2*a^2 - a + 1, a^5 - 3*a^4 - a^3 + 7*a^2 - 2*a - 1, a, a^3 - 2*a^2 - 2*a + 2, a^4 - 3*a^3 - a^2 + 6*a - 1]"}︡
︠38ab57c8-f5ad-4cd9-902f-cd9527d0e32fi︠
%html
<p>The key difficulty is implementing the L-Selmer group as a vector space. Robert Miller's function only gives a basis as elements of L--we need the structure of the actual group.</p>

︡1f6bad41-0312-4754-9285-dfc9bd29842b︡{"html": "<p>The key difficulty is implementing the L-Selmer group as a vector space. Robert Miller's function only gives a basis as elements of L--we need the structure of the actual group.</p>"}︡
︠0ae37704-74a5-46e5-ad8e-0d768ca98a5d︠
F2=FiniteField(2); F2
︡f699e662-3b1c-4dbf-94f0-62b04632c396︡{"stdout": "Finite Field of size 2"}︡
︠5d113321-9667-48c2-8484-024e4442b930︠
V=F2^(len(LSelmerGroup)); V
︡713cc8ff-640a-43d9-b6cb-f18c8f4d807c︡{"stdout": "Vector space of dimension 7 over Finite Field of size 2"}︡
︠9e2d67e5-6a6c-445c-bbfc-f3b949d9666ci︠
%html
<p>Two functions: this one goes from a vector to a Selmer class.</p>

︡1077d390-88b2-4e79-b4c4-672dbfa52285︡{"html": "<p>Two functions: this one goes from a vector to a Selmer class.</p>"}︡
︠789499d1-e538-4575-a7ed-f397e873c936︠
def V_to_Selmer(V, LSelmerGroup, v):
    a=1
    for i in range(dim(V)):
        a=a*(LSelmerGroup[i]^v[i])
    return a
︡633640a8-71a2-44aa-a90f-841c7936997d︡︡
︠bc6ddf11-3499-48ee-966a-d4ded78efa45i︠
%html
<p>This one goes the opposite way. It is by far the most time-consuming operation here.</p>

︡0ea14db8-b835-49cb-b593-cd0395b106ab︡{"html": "<p>This one goes the opposite way. It is by far the most time-consuming operation here.</p>"}︡
︠c41d0122-bb7b-4b6c-a6ac-ef710ff52305︠
def Selmer_to_V(V, LSelmerGroup, a):
    for v in V:
        if (a/V_to_Selmer(V, LSelmerGroup, v)).is_square()==True:
            return v
︡42c5c3c4-80c4-4241-b8ee-5927fb9c0510︡︡
︠90521842-2dc5-4999-a8cc-d782a5cced92i︠
%html
<p>Here we learn the Galois action on 2-torsion points.</p>

︡f127584a-50ca-47be-99ab-3fece000777d︡{"html": "<p>Here we learn the Galois action on 2-torsion points.</p>"}︡
︠5fcc19b5-2356-4781-b090-9f20e15df2e0︠
G=L.galois_group(); G
︡1b510095-f60d-41c3-b064-be4452f6fcc2︡{"stdout": "Galois group of Number Field in a with defining polynomial x^6 - 3*x^5 - 2*x^4 + 9*x^3 - 5*x + 1"}︡
︠dccca41f-9438-49b2-8939-6b966f8408f7︠
P=EL.division_polynomial(2).roots(multiplicities=False)[0]
︡90d304b8-d465-4163-969f-e6adea33dad6︡︡
︠05ce943e-93b1-4d70-8184-ccdd4399d6de︠
Q=EL.division_polynomial(2).roots(multiplicities=False)[2]
︡8107e02d-6faa-4587-a951-80c05ac1ee06︡︡
︠e9cd465f-3045-489c-b775-597f895b35f9︠
PQ=EL.division_polynomial(2).roots(multiplicities=False)[1]
︡5412d4ce-e24a-44a1-8874-d8c09cf6507d︡︡
︠cb4941ce-3a2d-48ab-9e5f-123c4ff3aa8a︠
tau=G.gens()[0]; sigma=G.gens()[1]^-1
︡0f0d2b16-b150-4ada-a353-ff7b7b631298︡︡
︠8c69ac27-a846-4d66-8973-defd9eca18c9︠
tau(P)==Q; tau(Q)==P; tau(PQ)==PQ; sigma(P)==Q; sigma(Q)==PQ; sigma(PQ)==P
︡6c1a4d8d-3be1-4f88-b423-ec16ccae21fc︡{"stdout": "True\nTrue\nTrue\nTrue\nTrue\nTrue"}︡
︠1de9aef7-24c9-4e32-b9e6-a2cc2d2d050di︠
%html
<p>W represents the tensor product vector space.</p>

︡81271063-474f-41f0-961a-ce8fd7808659︡{"html": "<p>W represents the tensor product vector space.</p>"}︡
︠39b5bcf5-7bfe-4b06-a766-7edcf69b83e3︠
W=F2^(2*len(LSelmerGroup)); W
︡1511d0ff-25cd-4c0a-b2d3-8cff3f2998ed︡{"stdout": "Vector space of dimension 14 over Finite Field of size 2"}︡
︠3dbb22d1-01da-4b6d-858b-3bcb85263f88i︠
%html
<p>Functions for dealing with the tensor product:</p>

︡df24c6cc-5e83-4441-96e1-b5ba3ac45ab5︡{"html": "<p>Functions for dealing with the tensor product:</p>"}︡
︠63e524fa-e164-4f99-90ab-276166dc9825︠
def Glue(u, v, V, W):
    w=W.zero_vector()
    for i in range(dim(V)):
        w[i]=u[i]
        w[i+dim(V)]=v[i]
    return w
︡4e99a3a1-f37e-4adc-8190-dfd9167bc4c7︡︡
︠16d40e6f-3a67-4e38-af3a-899ff35e7c5f︠
def Split(w, V, W):
    u=V.zero_vector(); v=V.zero_vector()
    for i in range(dim(V)):
        u[i]=w[i]
        v[i]=w[i+dim(V)]
    return [u, v]
︡4700e239-2b88-48b3-afff-669b04fc9ad5︡︡
︠d09e7a78-e415-4243-814a-d9c5cd531807i︠
%html
<p>Now we can write the Galois generators as matrices. They are big, but once constructed, Sage handles them with lightning speed.</p>

︡094d2036-282b-4f34-b39a-57ba8bf7e30c︡{"html": "<p>Now we can write the Galois generators as matrices. They are big, but once constructed, Sage handles them with lightning speed.</p>"}︡
︠d842a01a-79e3-4688-a3ab-4b6c8b3234b7︠
ListTau=list(W.basis())
for j in range(dim(V)):
    ListTau[j]=Glue(V.zero_vector(), Selmer_to_V(V, LSelmerGroup, tau(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
    ListTau[j+dim(V)]=Glue(Selmer_to_V(V, LSelmerGroup, tau(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V.zero_vector(), V, W)
MatrixTau=Matrix(ListTau); print MatrixTau.str()
︡b0c16e46-8027-49ac-b199-9a8827efc030︡{"stdout": "[0 0 0 0 0 0 0 1 1 1 0 0 1 0]\n[0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 1 0 0 1 0 0]\n[0 0 0 0 0 0 0 0 1 1 1 0 1 0]\n[0 0 0 0 0 0 0 0 1 1 0 0 0 0]\n[0 0 0 0 0 0 0 0 1 1 0 1 1 0]\n[0 0 0 0 0 0 0 0 0 1 0 1 0 1]\n[1 1 1 0 0 1 0 0 0 0 0 0 0 0]\n[0 1 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 1 0 0 1 0 0 0 0 0 0 0 0 0]\n[0 1 1 1 0 1 0 0 0 0 0 0 0 0]\n[0 1 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 1 1 0 1 1 0 0 0 0 0 0 0 0]\n[0 0 1 0 1 0 1 0 0 0 0 0 0 0]"}︡
︠343ce96f-4360-4edb-b1e6-4c849e5c812a︠
ListSigma=list(W.basis())
for j in range(dim(V)):
    ListSigma[j]=Glue(V.zero_vector(), Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
    ListSigma[j+dim(V)]=Glue(Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
MatrixSigma=Matrix(ListSigma); print MatrixSigma.str()
︡803970bd-3487-46fd-ae0f-83eb1a4c288d︡{"stdout": "[0 0 0 0 0 0 0 1 1 1 1 1 0 0]\n[0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 1 0 1 0 0 0]\n[0 0 0 0 0 0 0 0 1 1 1 0 0 0]\n[0 0 0 0 0 0 0 0 1 1 1 1 1 0]\n[0 0 0 0 0 0 0 0 1 1 0 1 0 0]\n[0 0 0 0 0 0 0 0 1 1 0 1 1 1]\n[1 1 1 1 1 0 0 1 1 1 1 1 0 0]\n[0 1 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 1 0 1 0 0 0 0 1 0 1 0 0 0]\n[0 1 1 1 0 0 0 0 1 1 1 0 0 0]\n[0 1 1 1 1 1 0 0 1 1 1 1 1 0]\n[0 1 1 0 1 0 0 0 1 1 0 1 0 0]\n[0 1 1 0 1 1 1 0 1 1 0 1 1 1]"}︡
︠4fdbfebd-0f3c-4ee9-9404-2c9ed29a9b4fi︠
%html
<p>Our problem is reduced to finding the common Eigenspace of these two matrices.</p>

︡6d331441-724b-4e75-a948-1f197989b75e︡{"html": "<p>Our problem is reduced to finding the common Eigenspace of these two matrices.</p>"}︡
︠7b6cb8c0-a71e-4e21-865d-b93f66937575︠
Id=Matrix(W.basis())
Eigens=(MatrixSigma-Id).left_kernel().intersection((MatrixTau-Id).left_kernel()); Eigens
︡82b7e533-a10c-46db-a713-bb1239891253︡{"stdout": "Vector space of degree 14 and dimension 2 over Finite Field of size 2\nBasis matrix:\n[0 0 0 1 1 0 0 0 0 0 1 0 1 0]\n[0 0 0 0 0 1 0 0 1 1 0 1 1 0]"}︡
︠a7e0aa19-1afd-420e-af53-c418c7a641b2︠
SelmerEigens=[[V_to_Selmer(V, LSelmerGroup, Split(w, V, W)[0]), V_to_Selmer(V, LSelmerGroup, Split(w, V, W)[1])] for w in Eigens]; SelmerEigens
︡660fb4a9-400f-43d2-b3b6-ebb2ca214993︡{"stdout": "[[1, 1], [a^4 - 2*a^3 - 2*a^2 + 4*a - 1, a^5 - 4*a^4 + a^3 + 9*a^2 - 5*a - 1], [a^3 - 2*a^2 - 2*a + 2, 2*a^4 - 5*a^3 - a^2 + 4*a - 1], [-a^5 + 3*a^4 - 5*a^2 + 4*a - 1, -a^2 + a]]"}︡
︠aa4c68e1-949b-49e2-a8cf-8e21266a1cc1i︠
%html
<p>We have bounded the Selmer group inside a group of size 4. Now finding it exactly is a matter of checking a modified local condition at primes above 2. We do this in a way that is surely sub-optimal: trying to divide a Mordell-Weil generator by two in various extension fields.</p>

︡f84258b7-37d7-4d84-8d80-453e9ceff6fb︡{"html": "<p>We have bounded the Selmer group inside a group of size 4. Now finding it exactly is a matter of checking a modified local condition at primes above 2. We do this in a way that is surely sub-optimal: trying to divide a Mordell-Weil generator by two in various extension fields.</p>"}︡
︠4e53f225-9dfa-473e-97c9-927a3e696a68︠
def MWDiv(EL, L, eig):
    RR.<tt>=L[]
    M.<b>=L.extension(tt^2-(eig[0]))
    SS.<uu>=M[]
    N.<c>=M.extension(uu^2-(eig[1]))
    EN=EL.change_ring(N)
    MWPoint=EN(0,0,1)
    return MWPoint.division_points(2)
︡66befb0a-6dd8-4a5b-8bf7-245474746ed5︡︡
︠eb4a0969-bacf-4a51-b9b8-033e8a425ccb︠
MWDiv(EL, L, SelmerEigens[1])
︡23fe1f45-18f9-4431-a7c4-cc4d4247f5c8︡{"stdout": "[(((-1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*b - 1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*c + (-1/2*a^5 + 3/2*a^4 + a^3 - 4*a^2 - a + 3/2)*b : ((1/2*a^5 - a^4 - 2*a^3 + 2*a^2 + 7/2*a + 1)*b + 1/2*a)*c + (a^5 - 5/2*a^4 - 3*a^3 + 7*a^2 + 3*a - 5/2)*b + 1/2 : 1), (((1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*b + 1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*c + (-1/2*a^5 + 3/2*a^4 + a^3 - 4*a^2 - a + 3/2)*b : ((-1/2*a^5 + a^4 + 2*a^3 - 2*a^2 - 7/2*a - 1)*b - 1/2*a)*c + (a^5 - 5/2*a^4 - 3*a^3 + 7*a^2 + 3*a - 5/2)*b + 1/2 : 1), (((1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*b - 1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*c + (1/2*a^5 - 3/2*a^4 - a^3 + 4*a^2 + a - 3/2)*b : ((-1/2*a^5 + a^4 + 2*a^3 - 2*a^2 - 7/2*a - 1)*b + 1/2*a)*c + (-a^5 + 5/2*a^4 + 3*a^3 - 7*a^2 - 3*a + 5/2)*b + 1/2 : 1), (((-1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*b + 1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*c + (1/2*a^5 - 3/2*a^4 - a^3 + 4*a^2 + a - 3/2)*b : ((1/2*a^5 - a^4 - 2*a^3 + 2*a^2 + 7/2*a + 1)*b - 1/2*a)*c + (-a^5 + 5/2*a^4 + 3*a^3 - 7*a^2 - 3*a + 5/2)*b + 1/2 : 1)]"}︡
︠aa25c807-9c6d-46fd-af75-c64dc53e86c3︠
MWDiv(EL, L, SelmerEigens[2])
︡63eb945f-8538-4bc0-8570-4bfaa2afddf2︡{"stdout": "[]"}︡
︠151525ab-0cc0-4470-8ef5-d8120df4adb8︠
MWDiv(EL, L, SelmerEigens[3])
︡e19df43e-97b6-4713-96e0-41cfdd35ea02︡{"stdout": "[]"}︡
︠a1702100-655a-4003-8deb-4b317ebc7863i︠
%html
<p>The first nonzero element in the list above is the true Selmer generator. The others fail. Hence the 2-Selmer group has rank 1, and so does E</p>

︡457e829d-821b-4ce7-9ba0-0bdb925878bb︡{"html": "<p>The first nonzero element in the list above is the true Selmer generator. The others fail. Hence the 2-Selmer group has rank 1, and so does E</p>"}︡
︠9bad1920-805d-4125-894a-18e7e7c142b4i︠
%html
<p>Now let's try a modified Selmer group, using the Kolyvagin prime 17.</p>

︡1d1f0a8f-5050-469f-8636-edaec2d10e14︡{"html": "<p>Now let's try a modified Selmer group, using the Kolyvagin prime 17.</p>"}︡
︠0b0d4713-c46c-4394-9a3e-eecd4558ddbc︠
List=list(set(L.primes_above(2)).union(set(L.primes_above(17)))); List
︡fa983a85-be66-48e0-9d09-ce3933ae7dbb︡{"stdout": "[Fractional ideal (a^5 - 2*a^4 - 4*a^3 + 4*a^2 + 6*a), Fractional ideal (a^3 - 2*a^2 - 2*a + 3), Fractional ideal (2*a^3 - 2*a^2 - 5*a), Fractional ideal (-a^5 + 3*a^4 + 2*a^3 - 10*a^2 + a + 5)]"}︡
︠d106f828-885e-4cf3-ae05-8bec2b52ad9c︠
LSelmerGroup=L.selmer_group(List, 2); LSelmerGroup
︡c0489f25-3f33-4eaa-8836-e60b420bd6c6︡{"stdout": "[a^5 - 2*a^4 - 4*a^3 + 4*a^2 + 6*a, a^3 - 2*a^2 - 2*a + 3, 2*a^3 - 2*a^2 - 5*a, -a^5 + 3*a^4 + 2*a^3 - 10*a^2 + a + 5, -1, a^3 - 2*a^2 - a + 1, a^5 - 3*a^4 - a^3 + 7*a^2 - 2*a - 1, a, a^3 - 2*a^2 - 2*a + 2, a^4 - 3*a^3 - a^2 + 6*a - 1]"}︡
︠ec9cc584-f9d7-4838-9e40-1d32ea9aa83f︠
V=F2^(len(LSelmerGroup)); V
︡922e5467-42bd-4b99-90ff-da0b2554bb7b︡{"stdout": "Vector space of dimension 10 over Finite Field of size 2"}︡
︠aeace5fa-008d-4186-8a71-6b9e2a48e881︠
W=F2^(2*len(LSelmerGroup)); W
︡01ed81e5-b7a7-4c2a-9d1a-fbed9852cda3︡{"stdout": "Vector space of dimension 20 over Finite Field of size 2"}︡
︠5f879c1e-f8c9-4b00-9fc2-15a88b502333︠
ListTau=list(W.basis())
for j in range(dim(V)):
    ListTau[j]=Glue(V.zero_vector(), Selmer_to_V(V, LSelmerGroup, tau(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
    ListTau[j+dim(V)]=Glue(Selmer_to_V(V, LSelmerGroup, tau(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V.zero_vector(), V, W)
MatrixTau=Matrix(ListTau); print MatrixTau.str()
︡524b7290-1445-4f19-850f-f727876778ac︡{"stdout": "[0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 1 0 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 0 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 1 1 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 1 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 0 1]\n[1 0 0 0 1 1 0 0 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 1 0 0 1 1 0 0 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 1 0 0 1 1 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 1 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 1 1 0 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 1 0 1 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 0 1 0 1 0 1 0 0 0 0 0 0 0 0 0 0]"}︡
︠1926b877-ec4f-47c3-bb93-7bdb854bbcff︠
ListSigma=list(W.basis())
for j in range(dim(V)):
    ListSigma[j]=Glue(V.zero_vector(), Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
    ListSigma[j+dim(V)]=Glue(Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
MatrixSigma=Matrix(ListSigma); print MatrixSigma.str()
︡78eee968-cf35-4b7f-b57f-aa889e3f3438︡{"stdout": "[0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 1 1 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 1 0 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 1 1 1]\n[0 0 1 0 1 1 1 1 0 0 0 0 1 0 1 1 1 1 0 0]\n[0 1 0 0 1 1 1 1 0 0 0 1 0 0 1 1 1 1 0 0]\n[0 0 0 1 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0]\n[1 0 0 0 1 1 0 0 1 0 1 0 0 0 1 1 0 0 1 0]\n[0 0 0 0 1 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 1 0 1 0 0 0 0 0 0 0 1 0 1 0 0 0]\n[0 0 0 0 1 1 1 0 0 0 0 0 0 0 1 1 1 0 0 0]\n[0 0 0 0 1 1 1 1 1 0 0 0 0 0 1 1 1 1 1 0]\n[0 0 0 0 1 1 0 1 0 0 0 0 0 0 1 1 0 1 0 0]\n[0 0 0 0 1 1 0 1 1 1 0 0 0 0 1 1 0 1 1 1]"}︡
︠fa5f4bd0-7166-485a-ab0b-09928f21adf5︠
Id=Matrix(W.basis())
Eigens=(MatrixSigma-Id).left_kernel().intersection((MatrixTau-Id).left_kernel()); Eigens
︡52805d23-78d5-46f7-a911-da3a329dd8d4︡{"stdout": "Vector space of degree 20 and dimension 3 over Finite Field of size 2\nBasis matrix:\n[1 0 1 0 0 0 0 0 0 0 1 0 0 1 1 1 1 1 0 0]\n[0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 1 0 1 0]\n[0 0 0 0 0 0 0 0 1 0 0 0 0 0 1 1 0 1 1 0]"}︡
︠aa17e3fd-689a-48a2-9525-5dde22ac8f3e︠
SelmerEigens=[[V_to_Selmer(V, LSelmerGroup, Split(w, V, W)[0]), V_to_Selmer(V, LSelmerGroup, Split(w, V, W)[1])] for w in Eigens]; SelmerEigens
︡38b22486-d219-4cf1-83e9-da2a47156b2d︡{"stdout": "[[1, 1], [-7*a^5 + 14*a^4 + 23*a^3 - 32*a^2 - 25*a + 5, -5*a^4 + 10*a^3 - a^2 - 4*a + 2], [a^4 - 2*a^3 - 2*a^2 + 4*a - 1, a^5 - 4*a^4 + a^3 + 9*a^2 - 5*a - 1], [-2*a^5 + 12*a^3 - 5*a^2 - 16*a + 4, -5*a^5 + 30*a^4 - 41*a^3 - 17*a^2 + 35*a - 8], [a^3 - 2*a^2 - 2*a + 2, 2*a^4 - 5*a^3 - a^2 + 4*a - 1], [5*a^5 - 10*a^4 - 14*a^3 + 18*a^2 + 13*a - 6, 5*a^5 - 19*a^4 + 2*a^3 + 43*a^2 - 16*a - 10], [-a^5 + 3*a^4 - 5*a^2 + 4*a - 1, -a^2 + a], [-a^5 + 6*a^3 + 6*a^2 - 8*a + 2, 2*a^4 - 4*a^3 - 3*a^2 + 5*a + 6]]"}︡
︠a574c790-e194-4370-95e1-b229f2936ce3i︠
%html
<p>To narrow down this group of size 8, we must check the transverse condition at primes above 17. The function below will do this:</p>

︡f9aa5137-5af3-476a-97ce-18b3a7b86cb4︡{"html": "<p>To narrow down this group of size 8, we must check the transverse condition at primes above 17. The function below will do this:</p>"}︡
︠01ada428-8fe9-48a9-9548-7f2a1939f441︠
def local_conditions(A, p, u, a):
    F=A.residue_field(p)
    vp=a.valuation(p)
    b=F(a/u^vp)
    unramified=(vp%2==0)
    transverse=(b.nth_root(2, all=True)!=[])
    return [unramified, transverse]
︡795d762c-09b1-4e69-b1be-a65926d85609︡︡
︠094ed478-7e9d-4c0d-b416-54f736b3b65b︠
I=L.ideal(17); factor(I)
︡e9c0e45f-a05d-48c1-8677-34f0ed0bed24︡{"stdout": "(Fractional ideal (-a^5 + 3*a^4 + 2*a^3 - 10*a^2 + a + 5)) * (Fractional ideal (2*a^3 - 2*a^2 - 5*a)) * (Fractional ideal (a^5 - 2*a^4 - 4*a^3 + 4*a^2 + 6*a))"}︡
︠ab2a20d6-e5fb-4a85-936c-3b447b193c05︠
for i in range(1, len(SelmerEigens)):
    SelmerEigens[i]
    for p in L.primes_above(17):
        local_conditions(L, p, 17, SelmerEigens[i][0])[1]
        local_conditions(L, p, 17, SelmerEigens[i][1])[1]
︡0145b144-45cb-487d-a800-10ae16bd0db5︡{"stdout": "[-7*a^5 + 14*a^4 + 23*a^3 - 32*a^2 - 25*a + 5, -5*a^4 + 10*a^3 - a^2 - 4*a + 2]\nTrue\nTrue\nTrue\nTrue\nTrue\nTrue\n[a^4 - 2*a^3 - 2*a^2 + 4*a - 1, a^5 - 4*a^4 + a^3 + 9*a^2 - 5*a - 1]\nTrue\nFalse\nFalse\nTrue\nFalse\nFalse\n[-2*a^5 + 12*a^3 - 5*a^2 - 16*a + 4, -5*a^5 + 30*a^4 - 41*a^3 - 17*a^2 + 35*a - 8]\nTrue\nFalse\nFalse\nTrue\nFalse\nFalse\n[a^3 - 2*a^2 - 2*a + 2, 2*a^4 - 5*a^3 - a^2 + 4*a - 1]\nTrue\nTrue\nTrue\nTrue\nTrue\nTrue\n[5*a^5 - 10*a^4 - 14*a^3 + 18*a^2 + 13*a - 6, 5*a^5 - 19*a^4 + 2*a^3 + 43*a^2 - 16*a - 10]\nTrue\nTrue\nTrue\nTrue\nTrue\nTrue\n[-a^5 + 3*a^4 - 5*a^2 + 4*a - 1, -a^2 + a]\nTrue\nFalse\nFalse\nTrue\nFalse\nFalse\n[-a^5 + 6*a^3 + 6*a^2 - 8*a + 2, 2*a^4 - 4*a^3 - 3*a^2 + 5*a + 6]\nTrue\nFalse\nFalse\nTrue\nFalse\nFalse"}︡
︠a8d44bde-5fe0-44e1-b896-02333c2de744i︠
%html
<p>Now the modified Selmer group is bounded in a group of size 4, and it suffices to check the local condition at 2.</p>

︡1025b026-e0a0-4da3-b7b2-44641e5d0f3d︡{"html": "<p>Now the modified Selmer group is bounded in a group of size 4, and it suffices to check the local condition at 2.</p>"}︡
︠b80985eb-c19b-4f2b-93fa-2db965338b53︠
MWDiv(EL, L, SelmerEigens[1])
︡b924cebd-e2eb-4943-a626-5d0014942421︡{"stdout": "[]"}︡
︠f0c189ae-c1af-4585-9e31-df6b6252a734︠
MWDiv(EL, L, SelmerEigens[4])
︡8a63e994-0117-4d1d-8ea8-ffb326ef0b7c︡{"stdout": "[]"}︡
︠3a039bde-f137-402e-8de8-96e6f4330b13︠
MWDiv(EL, L, SelmerEigens[5])
︡fe528386-b9d4-43f6-ae1a-9a990cc9389f︡{"stdout": "[]"}︡
︠75f30fc7-64aa-4b56-98ca-cad9a02eb97di︠
%html
<p>So this modified Selmer group turns out to be trivial.</p>

︡2ef610fc-d6f0-4cce-86af-660447ccf9ff︡{"html": "<p>So this modified Selmer group turns out to be trivial.</p>"}︡
︠3f24f5cf-9f21-4468-bc2e-3c15451603d4i︠
%html
<p>One more example, with Kolyvagin prime 29:</p>

︡6004e504-9695-4acc-8470-d08b6285d29c︡{"html": "<p>One more example, with Kolyvagin prime 29:</p>"}︡
︠84833eb8-4212-45ba-b4ec-9c28c3cc236b︠
List=list(set(L.primes_above(2)).union(set(L.primes_above(29)))); List
︡7025ed03-c87b-4132-9190-1fbdc51fa70c︡{"stdout": "[Fractional ideal (a^5 - 2*a^4 - 6*a^3 + 10*a^2 + 9*a - 8), Fractional ideal (a^3 - 2*a^2 - 2*a + 3), Fractional ideal (2*a^5 - 4*a^4 - 7*a^3 + 9*a^2 + 6*a), Fractional ideal (-a^5 + 3*a^4 + 4*a^3 - 10*a^2 - 8*a + 4)]"}︡
︠3f84e8c0-cd68-4b6b-875d-efbffa0943c0︠
LSelmerGroup=L.selmer_group(List, 2); LSelmerGroup
︡67401c7f-a85a-4235-b861-13762786b24f︡{"stdout": "[a^5 - 2*a^4 - 6*a^3 + 10*a^2 + 9*a - 8, a^3 - 2*a^2 - 2*a + 3, 2*a^5 - 4*a^4 - 7*a^3 + 9*a^2 + 6*a, -a^5 + 3*a^4 + 4*a^3 - 10*a^2 - 8*a + 4, -1, a^3 - 2*a^2 - a + 1, a^5 - 3*a^4 - a^3 + 7*a^2 - 2*a - 1, a, a^3 - 2*a^2 - 2*a + 2, a^4 - 3*a^3 - a^2 + 6*a - 1]"}︡
︠c8777e5d-a410-453a-9253-36c3408d63ac︠
V=F2^(len(LSelmerGroup)); V
︡3c162bf3-e424-4945-a27b-87419433f353︡{"stdout": "Vector space of dimension 10 over Finite Field of size 2"}︡
︠525383ce-d8f2-464f-9ac5-7500a321cd9e︠
W=F2^(2*len(LSelmerGroup)); W
︡b06b29e4-664a-4361-b926-40545c942224︡{"stdout": "Vector space of dimension 20 over Finite Field of size 2"}︡
︠48a253e4-3738-49c0-8461-4e17cab6e6e5︠
ListTau=list(W.basis())
for j in range(dim(V)):
    ListTau[j]=Glue(V.zero_vector(), Selmer_to_V(V, LSelmerGroup, tau(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
    ListTau[j+dim(V)]=Glue(Selmer_to_V(V, LSelmerGroup, tau(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V.zero_vector(), V, W)
MatrixTau=Matrix(ListTau); print MatrixTau.str()
︡b5d2acdc-93df-4be7-b4a6-cbbcd7ae0cfa︡{"stdout": "[0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 0 1 1 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 0 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 1 1 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 1 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 0 1]\n[0 0 1 0 1 0 1 1 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 1 0 0 1 1 0 0 1 0 0 0 0 0 0 0 0 0 0 0]\n[1 0 0 0 0 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 1 1 0 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 1 0 1 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 0 1 0 1 0 1 0 0 0 0 0 0 0 0 0 0]"}︡
︠cb4375ff-b9c9-491f-b8fb-c38fdc041b10︠
ListSigma=list(W.basis())
for j in range(dim(V)):
    ListSigma[j]=Glue(V.zero_vector(), Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
    ListSigma[j+dim(V)]=Glue(Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
MatrixSigma=Matrix(ListSigma); print MatrixSigma.str()
︡d61f250f-9ee6-4544-b17a-ab0f8896b5cd︡{"stdout": "[0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 1 0 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 0 1 1 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 1 1 1]\n[0 0 0 1 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0]\n[0 1 0 0 1 1 1 1 0 0 0 1 0 0 1 1 1 1 0 0]\n[1 0 0 0 0 1 0 0 1 0 1 0 0 0 0 1 0 0 1 0]\n[0 0 1 0 1 0 1 1 1 0 0 0 1 0 1 0 1 1 1 0]\n[0 0 0 0 1 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 1 0 1 0 0 0 0 0 0 0 1 0 1 0 0 0]\n[0 0 0 0 1 1 1 0 0 0 0 0 0 0 1 1 1 0 0 0]\n[0 0 0 0 1 1 1 1 1 0 0 0 0 0 1 1 1 1 1 0]\n[0 0 0 0 1 1 0 1 0 0 0 0 0 0 1 1 0 1 0 0]\n[0 0 0 0 1 1 0 1 1 1 0 0 0 0 1 1 0 1 1 1]"}︡
︠1cfad157-8f41-4b6f-9a13-3a412a4b1c1d︠
Id=Matrix(W.basis())
Eigens=(MatrixSigma-Id).left_kernel().intersection((MatrixTau-Id).left_kernel()); Eigens
︡c2138dd9-6d4c-4e85-b53e-1db2b8e75e36︡{"stdout": "Vector space of degree 20 and dimension 3 over Finite Field of size 2\nBasis matrix:\n[0 0 1 1 1 0 0 0 0 0 1 0 0 1 1 1 1 1 0 0]\n[0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 1 0 1 0]\n[0 0 0 0 0 0 0 0 1 0 0 0 0 0 1 1 0 1 1 0]"}︡
︠9ba8585c-eacb-432b-a5e7-9159b7a63ef0︠
SelmerEigens=[[V_to_Selmer(V, LSelmerGroup, Split(w, V, W)[0]), V_to_Selmer(V, LSelmerGroup, Split(w, V, W)[1])] for w in Eigens]; SelmerEigens
︡d9a1d2d1-358c-4aa2-9dd0-4caf7fdc8001︡{"stdout": "[[1, 1], [13*a^5 - 23*a^4 - 53*a^3 + 58*a^2 + 59*a - 18, -11*a^4 + 22*a^3 + 21*a^2 - 32*a + 4], [a^4 - 2*a^3 - 2*a^2 + 4*a - 1, a^5 - 4*a^4 + a^3 + 9*a^2 - 5*a - 1], [2*a^5 - 15*a^4 + 14*a^3 + 39*a^2 - 24*a + 4, -11*a^5 + 20*a^4 + 25*a^3 - 15*a^2 - 15*a + 6], [a^3 - 2*a^2 - 2*a + 2, 2*a^4 - 5*a^3 - a^2 + 4*a - 1], [-12*a^5 + 19*a^4 + 40*a^3 - 29*a^2 - 21*a + 1, -13*a^5 + 53*a^4 - 16*a^3 - 121*a^2 + 78*a + 6], [-a^5 + 3*a^4 - 5*a^2 + 4*a - 1, -a^2 + a], [16*a^5 - 33*a^4 - 33*a^3 + 51*a^2 - 18*a + 3, 4*a^4 - 8*a^3 - 5*a^2 + 9*a - 12]]"}︡
︠6a14324f-c0ae-40b2-90c7-cc64641716b9︠
for i in range(1, len(SelmerEigens)):
    i; SelmerEigens[i]
    for p in L.primes_above(29):
        local_conditions(L, p, 29, SelmerEigens[i][0])[1]
        local_conditions(L, p, 29, SelmerEigens[i][1])[1]
︡f2bbc653-64a3-448e-b6a8-2df33296d19d︡{"stdout": "1\n[13*a^5 - 23*a^4 - 53*a^3 + 58*a^2 + 59*a - 18, -11*a^4 + 22*a^3 + 21*a^2 - 32*a + 4]\nTrue\nTrue\nTrue\nTrue\nTrue\nTrue\n2\n[a^4 - 2*a^3 - 2*a^2 + 4*a - 1, a^5 - 4*a^4 + a^3 + 9*a^2 - 5*a - 1]\nTrue\nTrue\nTrue\nTrue\nTrue\nTrue\n3\n[2*a^5 - 15*a^4 + 14*a^3 + 39*a^2 - 24*a + 4, -11*a^5 + 20*a^4 + 25*a^3 - 15*a^2 - 15*a + 6]\nTrue\nTrue\nTrue\nTrue\nTrue\nTrue\n4\n[a^3 - 2*a^2 - 2*a + 2, 2*a^4 - 5*a^3 - a^2 + 4*a - 1]\nTrue\nFalse\nFalse\nTrue\nFalse\nFalse\n5\n[-12*a^5 + 19*a^4 + 40*a^3 - 29*a^2 - 21*a + 1, -13*a^5 + 53*a^4 - 16*a^3 - 121*a^2 + 78*a + 6]\nTrue\nFalse\nFalse\nTrue\nFalse\nFalse\n6\n[-a^5 + 3*a^4 - 5*a^2 + 4*a - 1, -a^2 + a]\nTrue\nFalse\nFalse\nTrue\nFalse\nFalse\n7\n[16*a^5 - 33*a^4 - 33*a^3 + 51*a^2 - 18*a + 3, 4*a^4 - 8*a^3 - 5*a^2 + 9*a - 12]\nTrue\nFalse\nFalse\nTrue\nFalse\nFalse"}︡
︠89722f80-a885-4f16-bd80-b9bf92b8e6c5︠
MWDiv(EL, L, SelmerEigens[1])
︡ba2b9237-4748-4404-99b1-f971653f5ba2︡{"stdout": "[]"}︡
︠181540ed-b2ba-412f-83d9-f50b5ce735d2︠
MWDiv(EL, L, SelmerEigens[2])
︡999710aa-66b7-4eb2-94ad-8f89b9273411︡{"stdout": "[(((-1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*b - 1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*c + (-1/2*a^5 + 3/2*a^4 + a^3 - 4*a^2 - a + 3/2)*b : ((1/2*a^5 - a^4 - 2*a^3 + 2*a^2 + 7/2*a + 1)*b + 1/2*a)*c + (a^5 - 5/2*a^4 - 3*a^3 + 7*a^2 + 3*a - 5/2)*b + 1/2 : 1), (((1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*b + 1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*c + (-1/2*a^5 + 3/2*a^4 + a^3 - 4*a^2 - a + 3/2)*b : ((-1/2*a^5 + a^4 + 2*a^3 - 2*a^2 - 7/2*a - 1)*b - 1/2*a)*c + (a^5 - 5/2*a^4 - 3*a^3 + 7*a^2 + 3*a - 5/2)*b + 1/2 : 1), (((1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*b - 1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*c + (1/2*a^5 - 3/2*a^4 - a^3 + 4*a^2 + a - 3/2)*b : ((-1/2*a^5 + a^4 + 2*a^3 - 2*a^2 - 7/2*a - 1)*b + 1/2*a)*c + (-a^5 + 5/2*a^4 + 3*a^3 - 7*a^2 - 3*a + 5/2)*b + 1/2 : 1), (((-1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*b + 1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*c + (1/2*a^5 - 3/2*a^4 - a^3 + 4*a^2 + a - 3/2)*b : ((1/2*a^5 - a^4 - 2*a^3 + 2*a^2 + 7/2*a + 1)*b - 1/2*a)*c + (-a^5 + 5/2*a^4 + 3*a^3 - 7*a^2 - 3*a + 5/2)*b + 1/2 : 1)]"}︡
︠414b4797-c39c-4fa9-a4a5-6770abd20702︠
MWDiv(EL, L, SelmerEigens[3])
︡9f3d1d89-45f6-478e-935b-48d04e68023f︡{"stdout": "[]"}︡
︠1e845e8f-36dd-4be5-8ce4-c00b76c5e042i︠
%html
<p>This at least tips us off that this modified Selmer group is nontrivial. But the theory of Kolyvagin systems predicts that it should have rank 2, not 1. I think the problem is that the local condition at 2 is implemented incorrectly. There must be a better test than the one I wrote. That would be the first priority for improving this code...</p>

︡7ad856c8-fe08-4f3c-9497-c706a8b05ecf︡{"html": "<p>This at least tips us off that this modified Selmer group is nontrivial. But the theory of Kolyvagin systems predicts that it should have rank 2, not 1. I think the problem is that the local condition at 2 is implemented incorrectly. There must be a better test than the one I wrote. That would be the first priority for improving this code...</p>"}︡
